from scrapy.spider import BaseSpider, Spider
from scrapy.http import Request
from crawler.items import CrawlerItem
import re

class Crawler(Spider): #Scrapy 0.22
#class Crawler(BaseSpider): #Scrapy 0.18
	name = 'img'

	def __init__(self):
		self.urlSet = set()
		fr = open('input.txt').readlines()
		self.mode = int(fr[0].strip())
		self.tmp = fr[1].strip()
		if self.mode == 1:
			self.allowed_domains = [self.tmp,]
			self.start_urls = ['http://' + self.tmp, ]
		else:
			self.allowed_domains = []
			self.start_urls = []

	def parse(self, response):
		html = response.body
		self.urlSet.add(response.url)
		reg = r'"[0-9a-z/_\.]+\.html"'
		urlReg = re.compile(reg)
		urlList = re.findall(urlReg,html)
		reg = r'"[0-9a-z/_\.]+\.jpg"|"[0-9a-z/_\.]+\.JPG"|"[0-9a-z/_\.]+\.png"|"[0-9a-z/_\.]+\.gif"'
		imgReg = re.compile(reg)
		imgList = re.findall(imgReg,html)

		for url in urlList:
			if url not in self.urlSet:
				yield Request('http://' + self.allowed_domains[0] + url.strip('"'), self.parse)
		
		item = CrawlerItem()
		item['url'] = response.url
		item['imgList'] = []
		for img in imgList:
			item['imgList'].append(img.strip('"'))

		yield item
